#include <stdlib.h>
#include <string.h>
#include "fdr_defines.h"

/* calculate score for each subsequence with length of w */
void score_subsequences(int numSeq,char **seq,char **rseq,int *seqLen,double **pwm,
   int motifLen,double **score,double **rscore) {

   register int ii,i,m;
   double plusScore,minusScore;
   int temp;

   for (ii=0;  ii<numSeq; ii++) {
      for(i=0;  i<seqLen[ii]-motifLen+1; i++) {
         plusScore=0;
         for (m=0; m<motifLen;m++) {
            if (seq[ii][i+m]=='n')  { plusScore=NON_ACGT; break;  }
            switch(seq[ii][i+m]) {
               case 'a': plusScore +=pwm[m][0]; break;
               case 'c': plusScore +=pwm[m][1]; break;
               case 'g': plusScore +=pwm[m][2]; break;
               case 't': plusScore +=pwm[m][3]; break;
               default: break;
            }
         }
         score[ii][i]=plusScore;
      }

      for(i=0;  i<seqLen[ii]-motifLen+1; i++){
         temp=seqLen[ii]-i-motifLen;
         minusScore=0;
         for (m=0; m<motifLen;m++) {
            if (rseq[ii][i+m]=='n') { minusScore=NON_ACGT; break; }
            switch(rseq[ii][i+m]) {
               case 'a': minusScore +=pwm[m][0]; break;
               case 'c': minusScore +=pwm[m][1]; break;
               case 'g': minusScore +=pwm[m][2]; break;
               case 't': minusScore +=pwm[m][3]; break;
               default: break;
            }
         }
         rscore[ii][temp]=minusScore;
      }
   }
}

